

// ------------------------------------------------------------------------------
//
// LudumDare.com 48hr compo, July 2002
//
// Dave Reed (Bluescreen)'s entry
//
// The flame particle system
//
// ------------------------------------------------------------------------------


#include <windows.h>
#include <gl\gl.h>
#include <math.h>

#include "winmain.h"
#include "game.h"
#include "sprites.h"
#include "flames.h"

SPRITE spFlames[16];
SPRITE spSlime[16];


extern float burning[32][32];
extern float damage[32][32];
extern char  map[32][32];

extern SPRITE spMainTiles[8];

FLAME flames[MAX_FLAMES];

void FLAMES_initTextures()
{
	int n;

	GL_loadTexture(128,"assets\\bigflames.png");    
	for(n=0;n<8;n++)
	{
		SPRITE_init(&spFlames[n],1.0f,2.0f,0.5f,0.5f,128,256,256,n*32,0,32,64);
		SPRITE_init(&spSlime[n],1.0f,2.0f,0.5f,0.5f,128,256,256,n*32,64,32,64);
	}
}


void FLAMES_init()
{
	int n;

	for(n=0;n<MAX_FLAMES;n++)
	{
		flames[n].type=FLAME_NONE;
	}
}


/*
void FLAME_addSlime(int x,int y)
{
	int n=0;

	if (x>31 || y>31 || x<0 || y<0) return;

	for(n=0;n<MAX_FLAMES;n++)
	{
		if (flames[n].type==FLAME_NONE)
		{
			flames[n].type=FLAME_BIG;
			flames[n].vPos.x=x;
			flames[n].vPos.y=y;
			flames[n].vPos.z=-1.0f; //-1.0f;
			flames[n].tx=x;
			flames[n].ty=y;
			flames[n].size=0.3f;
			flames[n].t=((float)(rand()))/1000.0f;

			goto done;
		}
	}

	done: return;
}

*/

// Attaches a flame to a tile
void FLAME_add(int x,int y)
{
	int n=0;

	if (x>31 || y>31 || x<0 || y<0) return;

	if (burning[x][y]!=0.0f) return;	

	for(n=0;n<MAX_FLAMES;n++)
	{
		if (flames[n].type==FLAME_NONE)
		{
			flames[n].type=FLAME_BIG;
			flames[n].vPos.x=x;
			flames[n].vPos.y=y;
			flames[n].vPos.z=-1.0f; //-1.0f;
			flames[n].tx=x;
			flames[n].ty=y;
			flames[n].size=0.3f;
			flames[n].t=((float)(rand()))/1000.0f;

			burning[x][y]=0.0001f;

			SFX_play(SFX_IGNITE);
			goto done;
		}
	}

	done: return;
}


void FLAME_addSpark(int x,int y)
{
	int n=0;

	for(n=0;n<MAX_FLAMES;n++)
	{
		if (flames[n].type==FLAME_NONE)
		{
			float v=(rand()%20)+15.0f;
			float u=(rand()%20)-10.0f;

			flames[n].type=FLAME_SPARK;
			flames[n].vPos.x=x;
			flames[n].vPos.y=y;
			flames[n].vPos.z=-1.0f; //-1.0f;
			flames[n].life=1.0f;

			{
				// Spark
				flames[n].vVel.x=(-gameInfo.vGrav.x*v)+(gameInfo.vGrav.y*u);
				flames[n].vVel.y=(-gameInfo.vGrav.y*v)+(gameInfo.vGrav.x*u);

				flames[n].vPos.x-=gameInfo.vGrav.x*130.0f;
				flames[n].vPos.y-=gameInfo.vGrav.y*130.0f;
			}


			goto done;
		}
	}

	done: return;
}





void FLAME_addSlime(int x,int y)
{
	int n=0;

	for(n=0;n<MAX_FLAMES;n++)
	{
		if (flames[n].type==FLAME_NONE)
		{
			float v=(rand()%20)+15.0f;
			float u=(rand()%20)-10.0f;

			flames[n].type=FLAME_SLIME;
			flames[n].vPos.x=x;
			flames[n].vPos.y=y;
			flames[n].vPos.z=-1.0f; //-1.0f;
			flames[n].life=1.0f;	

			{				
				flames[n].vVel.x=(gameInfo.vGrav.x*v);
				flames[n].vVel.y=(gameInfo.vGrav.y*v);

				flames[n].vPos.x+=gameInfo.vGrav.x*130.0f;
				flames[n].vPos.y+=gameInfo.vGrav.y*130.0f;
			}

			if ((rand()%7)>5) SFX_play(SFX_DRIP+(rand()%3));

			goto done;
		}
	}

	done: return;
}


void FLAMES_update()
{
	int n;
	float fuel,rsize,idam;

	glBlendFunc(GL_ONE,GL_ONE); //SRC_COLOR,GL_ONE);	
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);

	glColor3f(1.0f,1.0f,1.0f);

	gameInfo.flameCount=0;

	for(n=0;n<MAX_FLAMES;n++)
	{
		FLAME *f=&flames[n];

		switch(flames[n].type)
		{
			case FLAME_SPARK:
				
				gameInfo.flameCount++;

				f->t+=0.06f;
				f->life-=0.01f;

				if (f->life<=0) f->type=FLAME_NONE;

				SPRITE_blit(&spFlames[3],&f->vPos,-gameInfo.worldAngle,(0.65f)*f->life);

				f->vPos.x+=f->vVel.x;

				

					if (f->life<0.8f)				
					{
						int tx=((int)(f->vPos.x+0.5f));
						int ty=((int)(f->vPos.y+0.5f));
				
						if (tx<32 && ty<32 && tx>=0 && ty>=0) 						
							if(map[tx][ty])
							{
								f->vVel.x=-f->vVel.x/2.0f;

								if (f->life>0.5f)
								{
									if (map[tx][ty]==1) FLAME_add(tx,ty);
									
									if (damage[tx][ty]==0.0f)
									{
										gameInfo.damaged++;
										damage[tx][ty]=0.01f;								
									}
									
								}							
							}
					}


					f->vPos.y+=f->vVel.y;

					
					if (f->life<0.8f)				
					{
						int tx=((int)(f->vPos.x+0.5f));
						int ty=((int)(f->vPos.y+0.5f));
				
						if (tx<32 && ty<32 && tx>=0 && ty>=0) 						
							if( map[tx][ty])
							{
								f->vVel.y=-f->vVel.y/2.0f;

								
								if ( f->life>0.5f)
								{
									if (map[tx][ty]==1) FLAME_add(tx,ty);							
									
									if (damage[tx][ty]==0.0f)
									{
										gameInfo.damaged++;
										damage[tx][ty]=0.01f;								
									}
									
								}
							}
					}
				


				f->vVel.x+=gameInfo.vGrav.x;
				f->vVel.y+=gameInfo.vGrav.y;

				SPRITE_blit(&spFlames[2],&f->vPos,-gameInfo.worldAngle,(0.65f)*f->life);				

				break;


			case FLAME_SLIME:
				f->t+=0.06f;
				f->life-=0.01f;

				if (f->life<=0) f->type=FLAME_NONE;
		

					f->vPos.x+=f->vVel.x;
				
					if (f->life<0.9f)				
					{
						int tx=((int)(f->vPos.x+0.5f));
						int ty=((int)(f->vPos.y+0.5f));
				
						if (tx<32 && ty<32 && tx>=0 && ty>=0) 						
							if(map[tx][ty])
							{
								f->vVel.x=0;
								if (burning[tx][ty]>0.0f) 
								{									
									burning[tx][ty]-=0.25f;
									if ((rand()%100)>80) SFX_play(SFX_HISS);

									f->type=FLAME_SMOKE;
									f->life=1.0f;
								}
							}
					}



					f->vPos.y+=f->vVel.y;
					
					if (f->life<0.9f)				
					{
						int tx=((int)(f->vPos.x+0.5f));
						int ty=((int)(f->vPos.y+0.5f));
				
						if (tx<32 && ty<32 && tx>=0 && ty>=0) 						
							if( map[tx][ty])
							{
								f->vVel.y=0;
								if (burning[tx][ty]>0.0f) 
								{
									burning[tx][ty]-=0.25f;
									f->type=FLAME_SMOKE;
									f->life=1.0f;
								}
							}
					}
				


				f->vVel.x+=gameInfo.vGrav.x;
				f->vVel.y+=gameInfo.vGrav.y;

				SPRITE_blit(&spSlime[0],&f->vPos,-gameInfo.worldAngle,(0.65f)*f->life);				

				break;


			case FLAME_SMOKE:
				f->t+=0.06f;
				f->life-=0.01f;

				if (f->life<=0) f->type=FLAME_NONE;
		

				f->vPos.x+=f->vVel.x;
							
				f->vPos.y+=f->vVel.y;
					

				f->vVel.x=-gameInfo.vGrav.x*15.0f;
				f->vVel.y=-gameInfo.vGrav.y*15.0f;

				glColor3f(f->life/2.0f,f->life/2.0f,f->life/2.0f);
				SPRITE_blit(&spSlime[1],&f->vPos,f->life*180.0f,0.6f+(f->life*1.3f));				
				SPRITE_blit(&spSlime[1],&f->vPos,-f->life*180.0f,0.6f+(f->life*1.3f));				
				glColor3f(1.0f,1.0f,1.0f);

				break;




			case FLAME_BIG:
				f->t+=0.06f;

				gameInfo.flameCount++;

				burning[f->tx][f->ty]+=0.00375f;

				if (burning[f->tx][f->ty]<0) f->type=FLAME_NONE;


				idam=1.0f-(damage[f->tx][f->ty]/2.0f);

				if (burning[f->tx][f->ty]>idam) burning[f->tx][f->ty]=idam;

				if (damage[f->tx][f->ty]==0) damage[f->tx][f->ty]=0.1f;				
				
				rsize=1.3f*burning[f->tx][f->ty];				
				//burning[f->tx][f->ty]=rsize;

				SPRITE_blit(&spFlames[0],&f->vPos,-gameInfo.worldAngle,0.7f+((1.2f+(sin(f->t)*0.4f))*rsize));
				SPRITE_blit(&spFlames[1],&f->vPos,-gameInfo.worldAngle,0.7f+((1.2f+(cos(f->t)*0.4f))*rsize));

				// Spawn a spark
				if (rsize>0.5f)
				{
					if ((rand()%50)==0)
					{
						FLAME_addSpark(f->tx,f->ty);
					}
				}

				// burn the platform!
				if ((rand()&15)==1)
				{
					damage[f->tx][f->ty]+=0.025f;

					if (damage[f->tx][f->ty]>=1.0f)
					{
						int t;
						map[f->tx][f->ty]=0;
						gameInfo.destroyed++;

						f->type=FLAME_NONE;
						burning[f->tx][f->ty]=0.0f;

						for(t=0;t<8;t++) FLAME_addSpark(f->tx,f->ty);

						SFX_play(SFX_POP);
					}
				}
				
			
		}
	}


	if (gameInfo.flameCount==0) gameInfo.state=GAME_ENDOFPLAY;

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
}

